package edu.berkeley.cs160.group7.BeenThereDoneThatHiFi;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.StringTokenizer;

import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

public class CurrentStatus extends Activity {
	
	// Shared preferences file where all the game data like username will be stored
	public static SharedPreferences mGameData = null;
    public static SharedPreferences.Editor mGameDataEditor = null;
    
    private static final int ABOUT_LEVELS = 1;
    private static final int ABOUT_RANK = 2;
    private static final int NOVICE = 1;
    private static final int SMALL = 100;
    private static final int RECREATIONAL = 200;
    private static final int REAL = 1000;
    private static final int EPIC = 2000;
	
	private Button mAboutLevelsButton, mMainMenuButton, mOnlineRankButton;
	
	private TextView mItemsCount, mLevel, mItemsNeeded, mRank;
	
	@Override
	protected void onCreate(Bundle icicle) {
		int ItemCount, NextLevel;
		String CurrentLevel;
		
		super.onCreate(icicle);
		mGameData = getSharedPreferences(Launcher.STORAGE_FILE,MODE_PRIVATE);
        mGameDataEditor = mGameData.edit();
        
		setContentView(R.layout.current_status);
		mItemsCount = (TextView) findViewById(R.id.items_count);
		mLevel = (TextView) findViewById(R.id.current_level);
		mItemsNeeded = (TextView) findViewById(R.id.items_needed);
		mRank = (TextView) findViewById(R.id.current_rank);
		
		
		mAboutLevelsButton = (Button) findViewById(R.id.about_levels_button);
		mMainMenuButton = (Button) findViewById(R.id.main_menu_button);
		mOnlineRankButton = (Button) findViewById(R.id.online_rank_button);
		
		ItemCount = 0;

		
		if (ItemCount < NOVICE) {
			CurrentLevel = "Novice Scavenger";
			NextLevel = NOVICE - ItemCount;
		} else if (ItemCount < SMALL) {
			CurrentLevel = "Small Scavenger";
			NextLevel = SMALL - ItemCount;
		}  else if (ItemCount < RECREATIONAL) {
			CurrentLevel = "Recreational Scavenger";
			NextLevel = RECREATIONAL - ItemCount;
		}  else if (ItemCount < REAL) {
			CurrentLevel = "Real Scavenger";
			NextLevel = REAL - ItemCount;
		}  else if (ItemCount < EPIC) {
			CurrentLevel = "Epic Scavenger";
			NextLevel = EPIC - ItemCount;
		} else {
			CurrentLevel = "Epic Scavenger";
			NextLevel = 0;
		} 

		mItemsCount.setText(ItemCount + " points collected");
		mLevel.setText("Current Level: " + CurrentLevel);
		if (NextLevel != 0) {
			mItemsNeeded.setText("(" + NextLevel + " points to next level)");
		}
		
		updateRank();
		
		//Button Actions
		mMainMenuButton.setOnClickListener(
			new OnClickListener() {
				public void onClick(View v) {
					finish();
				}
			});
		
		mAboutLevelsButton.setOnClickListener(
				new OnClickListener() {
					public void onClick(View v) {
						gotoAboutLevels();
					}
				});
		
		mOnlineRankButton.setOnClickListener(
				new OnClickListener() {
					public void onClick(View v) {
						gotoAboutRank();
					}
				});
	}

	@Override
	protected void onActivityResult(int requestCode, int resultCode,
			String data, Bundle extras) {
		switch(requestCode) {
		case ABOUT_LEVELS:
			if(resultCode == RESULT_CANCELED){
				finish();
			}else{
				super.onActivityResult(requestCode, resultCode, data, extras);
			}
			break;
		case ABOUT_RANK:
			if(resultCode == RESULT_CANCELED){
				finish();
			}else{
				super.onActivityResult(requestCode, resultCode, data, extras);
			}
			break;
		default :
			super.onActivityResult(requestCode, resultCode, data, extras);
		}
		
	}

	private void gotoAboutLevels(){
		Intent i;
		i = new Intent(CurrentStatus.this, AboutLevels.class);
		i.putExtra("Activity",ABOUT_LEVELS);
		startSubActivity(i,ABOUT_LEVELS);
	}
	
	private void gotoAboutRank(){
		Intent i;
		i = new Intent(CurrentStatus.this, AboutLevels.class);
		i.putExtra("Activity",ABOUT_RANK);
		startSubActivity(i,ABOUT_RANK);
	}
	
	private void updateRank(){
		// thought this should be auto done
		// whenever you check online, it will automatically update :)
		String onlineId = mGameData.getString("onlineId",null);
		String username = mGameData.getString("Username",null);
		String score = "0"; 
		int ItemCount;

		String line="";
		String temp="";
		String ranking = "";
		String totalUsers="";
		String CurrentLevel;
		int NextLevel;
		
		
		String url = "http://khoaphung.com/android/ranking2.jsp?onlineId="+onlineId+"&username="+username+"";
		try{
            BufferedReader in = new BufferedReader (new InputStreamReader (new URL (url).openStream()));
            while((line = in.readLine()) != null ){
                temp = temp+line;
            }
            StringTokenizer st = new StringTokenizer(temp, ",");
            while(st.hasMoreTokens()){
            	ranking = st.nextToken();
            	score = st.nextToken();
            }
            score = score.trim();
            ranking = ranking.replaceAll("\\t","");
        }catch(Exception e){
        }
        ItemCount = Integer.parseInt(score);
        if (ItemCount < NOVICE) {
			CurrentLevel = "Novice Scavenger";
			NextLevel = NOVICE - ItemCount;
		} else if (ItemCount < SMALL) {
			CurrentLevel = "Small Scavenger";
			NextLevel = SMALL - ItemCount;
		}  else if (ItemCount < RECREATIONAL) {
			CurrentLevel = "Recreational Scavenger";
			NextLevel = RECREATIONAL - ItemCount;
		}  else if (ItemCount < REAL) {
			CurrentLevel = "Real Scavenger";
			NextLevel = REAL - ItemCount;
		}  else if (ItemCount < EPIC) {
			CurrentLevel = "Epic Scavenger";
			NextLevel = EPIC - ItemCount;
		} else {
			CurrentLevel = "Epic Scavenger";
			NextLevel = 0;
		} 
        
        
        totalUsers = getTotalUser();
        mRank.setText("Ranking: "+ranking+" out of "+totalUsers+" "); // changed from mTitle
        mItemsCount.setText(ItemCount + " points collected");
		mLevel.setText("Current Level: " + CurrentLevel);
		if (NextLevel != 0) {
			mItemsNeeded.setText("(" + NextLevel + " points to next level)");
		}
	}
	private int itemCount(){
		String line="";
        String temp="";
        String onlineId = mGameData.getString("onlineId",null);
        String username = mGameData.getString("Username",null);
		try{
        	temp = "";
        	line = "";
            BufferedReader in = new BufferedReader (new InputStreamReader (new URL ("http://khoaphung.com/android/itemCount.jsp?onlineId="+onlineId+"&username="+username+"").openStream()));
            while((line = in.readLine()) != null ){
                temp = temp+line;
            }
            temp = temp.trim();
		}catch(Exception e){
		}
		return Integer.parseInt(temp);
	}
	
	private int getUserPoints(){
		String line="";
        String temp="";
        String onlineId = mGameData.getString("onlineId",null);

		try{
        	temp = "";
        	line = "";
            BufferedReader in = new BufferedReader (new InputStreamReader (new URL ("http://khoaphung.com/android/getUserPoints.jsp?onlineId="+onlineId+"").openStream()));
            while((line = in.readLine()) != null ){
                temp = temp+line;
            }
            temp = temp.trim();
		}catch(Exception e){
		}
		return Integer.parseInt(temp);
	}
	
	public static String onlineRanking(){
		// thought this should be auto done
		// whenever you check online, it will automatically update :)
		String onlineId = mGameData.getString("onlineId",null);
		String username = mGameData.getString("Username",null); 

		String line="";
		String temp="";
		String rank="";
		String user="";
		String points="";
		String returnString="";
		
		
		
		String url = "http://khoaphung.com/android/ranking3.jsp?onlineId="+onlineId+"&username="+username+"";
		try{
            BufferedReader in = new BufferedReader (new InputStreamReader (new URL (url).openStream()));
            while((line = in.readLine()) != null ){
                temp = temp+line;
            }
            StringTokenizer st = new StringTokenizer(temp, ",");
            while(st.hasMoreTokens()){
            	rank = st.nextToken();
            	user = st.nextToken();
            	points = st.nextToken();
            	returnString += "Rank: "+rank+"  \t  Points: "+points+"   \t  User: "+user+"\n";
            }
        }catch(Exception e){
        }

        return returnString;
	}
	public static String getTotalUser(){
		// thought this should be auto done
		// whenever you check online, it will automatically update :)
		String line="";
		String temp="";
		String url = "http://khoaphung.com/android/ranking4.jsp";
		try{
            BufferedReader in = new BufferedReader (new InputStreamReader (new URL (url).openStream()));
            while((line = in.readLine()) != null ){
                temp = temp+line;
            }
        }catch(Exception e){
        }

        return temp;
	}
	
}
