package edu.berkeley.cs160.group7.BeenThereDoneThatHiFi;

import android.app.Activity;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ScrollView;
import android.widget.TextView;

public class HelpMenu extends Activity {
	
	private static final int HELPMENU = 100;
	private static final int HELP0 = 0;
	private static final int HELP1 = 1;
	private static final int HELP2 = 2;
	private static final int HELP3 = 3;
	
	private static final String CONTENT0 = ""+
	"'Been There, Done That!' uses GPS to let you go to physical locations to pick up "+
	"virtual items all around the world. Your goal is to collect as many items as possible to become "+
	"an expert scavenger.";

	private static final String CONTENT1 = ""+
	"Settings let you change various game features\n\n"+
	"GAME SOUNDS: \n "+
	"    \"Sound Occurs\" lets you turn game sounds on or off.\n  "+
	"    \"Volume\" lets you set the volume.\n\n"+
	"ITEM ALERT: \n "+
	"    \"Alert Mode\" lets you choose different ways the game will alert you when an item is nearby, such as launch application "+
	"pop-up note, and no alert.\n "+
	"    \"Alert Sound\" lets you either set the alerts with the Game Sounds, With current Profile, or No Sounds at all.\n "+
	"    \"Alert Level\" lets you have different alert settings for nearby items and somewhat near items.\n\n"+
	"CHANGE ICON: lets you change your icon.\n  "+
	"RESET GAME: lets you reset the game and erase all game data.\n  "+
	"";
	
	
	private static final String CONTENT2 = ""+
	"The map will display your current location and items in your vicinity. Move around until your location icon overlaps one of the items and click the Select button "+
	"to pick up, ignore, or examine the item. \n\n If none are available, it will pop up a screen with a notification and show your current location."+
	"";

	
	private static final String CONTENT3 = ""+
	"LOOK AT LOOT will display your current inventory of items with descriptions."+
	"";
	
	private int mCurrentView;
	private View mCurrentFocus = null;
	
	private Button mHelp0Button, mHelp1Button, mHelp2Button, mHelp3Button, mMainMenuButton;
	private TextView mTitle, mContent;
	private ScrollView mContentScroll;
	
	@Override
	protected void onCreate(Bundle icicle) {
		super.onCreate(icicle);
		if(icicle != null){
			mCurrentView = icicle.getInt("current_view");
			gotoHelp(mCurrentView);
			mCurrentFocus = findViewById(icicle.getInt("focus_id"));
			mCurrentFocus.requestFocus();
		}else{
			gotoHelp(HELPMENU);
		}  
	}
	
	@Override
	protected void onFreeze(Bundle outState) {
		super.onFreeze(outState);
		outState.putInt("current_view", mCurrentView);
		mCurrentFocus = getCurrentFocus();
		outState.putInt("focus_id", mCurrentFocus.getId());
	}
	
	@Override
	protected void onPause() {
		super.onPause();
		mCurrentFocus = getCurrentFocus();
	}

	@Override
	protected void onResume() {
		super.onResume();
		if(mCurrentFocus != null){
			mCurrentFocus.requestFocus();
		}
	}

	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		switch (keyCode) {
		case KeyEvent.KEYCODE_BACK:
			if(mCurrentView == HELP0 || mCurrentView == HELP1 || mCurrentView == HELP2 || mCurrentView == HELP3){
				gotoHelp(HELPMENU);
			}else{
				finish();
			}
			return true;
		default:
			return super.onKeyDown(keyCode, event);
		}
	}
	
	private void gotoHelp(int index){
		
		if(index == HELP0){
			mCurrentView = HELP0;
			setContentView(R.layout.help);
			mTitle = (TextView) findViewById(R.id.title);
			mContent = (TextView) findViewById(R.id.content);
			mContentScroll = (ScrollView) findViewById(R.id.help_scroll);
			mContent.setVerticalScrollBarEnabled(true);
			mTitle.setText(mTitle.getText()+">Overview");
			mContent.setText(CONTENT0);
			mContentScroll.requestFocus();
		}
		if(index == HELP1){
			mCurrentView = HELP1;
			setContentView(R.layout.help);
			mTitle = (TextView) findViewById(R.id.title);
			mContent = (TextView) findViewById(R.id.content);
			mContentScroll = (ScrollView) findViewById(R.id.help_scroll);
			mContent.setVerticalScrollBarEnabled(true);
			mTitle.setText(mTitle.getText()+">Settings");
			mContent.setText(CONTENT1);
			mContentScroll.requestFocus();
		}
		if(index == HELP2){
			mCurrentView = HELP2;
			setContentView(R.layout.help);
			mTitle = (TextView) findViewById(R.id.title);
			mContent = (TextView) findViewById(R.id.content);
			mContentScroll = (ScrollView) findViewById(R.id.help_scroll);
			mContent.setVerticalScrollBarEnabled(true);
			mTitle.setText(mTitle.getText()+">Using Map");
			mContent.setText(CONTENT2);
			mContentScroll.requestFocus();	
		}
		if(index == HELP3){
			mCurrentView = HELP3;
			setContentView(R.layout.help);
			mTitle = (TextView) findViewById(R.id.title);
			mContent = (TextView) findViewById(R.id.content);
			mContentScroll = (ScrollView) findViewById(R.id.help_scroll);
			mContent.setVerticalScrollBarEnabled(true);
			mTitle.setText(mTitle.getText()+">Viewing Items");
			mContent.setText(CONTENT3);
			mContentScroll.requestFocus();
		}
		if(index == HELPMENU){
			mCurrentView = HELPMENU;
			setContentView(R.layout.help_menu);

			mHelp0Button = (Button) findViewById(R.id.help0_button);
			mHelp1Button = (Button) findViewById(R.id.help1_button);
			mHelp2Button = (Button) findViewById(R.id.help2_button);
			mHelp3Button = (Button) findViewById(R.id.help3_button);
			mHelp0Button.requestFocus();

			mMainMenuButton = (Button) findViewById(R.id.main_menu_button);
			
			mHelp0Button.setOnClickListener(
				new OnClickListener() {
					public void onClick(View v) {
						gotoHelp(HELP0);
					}
				});
			
			mHelp1Button.setOnClickListener(
					new OnClickListener() {
						public void onClick(View v) {
							gotoHelp(HELP1);
						}
					});
			
			mHelp2Button.setOnClickListener(
					new OnClickListener() {
						public void onClick(View v) {
							gotoHelp(HELP2);
						}
					});
			
			mHelp3Button.setOnClickListener(
					new OnClickListener() {
						public void onClick(View v) {
							gotoHelp(HELP3);
						}
					});
			mMainMenuButton.setOnClickListener(
					new OnClickListener() {
						public void onClick(View v) {
							finish();
						}
					});
		}
    }
}

