package edu.berkeley.cs160.group7.BeenThereDoneThatHiFi;

import java.util.ArrayList;

import android.app.Notification;
import android.app.NotificationManager;
import android.app.Service;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.IBinder;
import android.os.Looper;
import android.util.Log;
import android.widget.Toast;

import com.google.android.maps.Point;

import edu.berkeley.cs160.group7.BeenThereDoneThatHiFi.MapBrowser.Item;

public class ItemScanner extends Service implements Runnable {
	
    public static final int LAUNCH_LAUNCHER = 0;
    public static final int LAUNCH_MAP = 1;
	public static SharedPreferences mGameData = null;
    public static SharedPreferences.Editor mGameDataEditor = null;
    
	// Use a layout id for a unique identifier as per apidemos
    private static final int NOTIFICATION_ID = R.layout.launcher;
 
	private NotificationManager mNotificationManager;

	
	public void run() {	
		
	
		while(true) {
			try {
				Thread.sleep(10000);
		    //Thread.sleep(60000); // 60000 milliseconds = 1 min
			} catch (InterruptedException iE) 
			{
				Thread.currentThread().interrupt();
			}
			Log.d("YAY", "PRE1");
			Looper.prepare();

			Log.d("YAY", "PRE2");
			if(isItemAround()){
				showNotification();
				makeAlertSound();
				doAlertMode();
				Log.d("YAY", "TESTING");
			}
			Log.d("YAY", "POST1");
			Looper.loop();
			Log.d("YAY", "POST2");
			Looper.myLooper().quit();
			Log.d("YAY", "POST3");
			try {
				Thread.sleep(5000);
		    //Thread.sleep(60000); // 60000 milliseconds = 1 min
			} catch (InterruptedException iE) 
			{
				Thread.currentThread().interrupt();
			}
		}
		
	}

	@Override
	protected void onCreate()
	{
		super.onCreate();
		mGameData = getSharedPreferences(Launcher.STORAGE_FILE,MODE_PRIVATE);
        mGameDataEditor = mGameData.edit();
		Thread mScanner = new Thread(null, this, "BeenThereDoneThatScanner");
		mNotificationManager = (NotificationManager) getSystemService(NOTIFICATION_SERVICE);
		mScanner.start();
	}

	@Override
	public IBinder onBind(Intent intent) {
		return null;
	}
	
	@Override
	protected void onDestroy() {
		super.onDestroy();
        // Cancel the persistent notification.
		mNotificationManager.cancel(NOTIFICATION_ID);
	}
	// for all of the below access the preference file using 
	// the strings I defined at the top of settingsmenu
	// probably will need to check with khoa's server to find out if items are around
	private boolean isItemAround(){
		// TODO: Check the Alert Level and return true/false
		// if setting is CLOSE and item can be seen on map return true
		// if setting is FAR and item can be seen in map or little past map return true
		// else return false
		
		ArrayList<Item> items;
		if (mGameData.getInt(SettingsMenu.PREF_ALERTSTATUS, SettingsMenu.ITEM_ALERT_OFF_VIEW) == SettingsMenu.ITEM_ALERT_ON_VIEW) {
			// if CLOSE
			if (mGameData.getInt(SettingsMenu.PREF_ALERTLEVEL, 3) == 0) {
				items = MapBrowser.getItems(new Point(mGameData.getInt(MapBrowser.PREF_LATITUDE, MapBrowser.DEFAULT_LATITUDE),
														  mGameData.getInt(MapBrowser.PREF_LONGITUDE, MapBrowser.DEFAULT_LONGITUDE)), 0, mGameData);
				if (items != null) {
					return true;
				} else {
					return false;
				}
				
			// if FAR
			} else if (mGameData.getInt(SettingsMenu.PREF_ALERTLEVEL, 3) == 1) {
				items = MapBrowser.getItems(new Point(mGameData.getInt(MapBrowser.PREF_LATITUDE, MapBrowser.DEFAULT_LATITUDE),
						  mGameData.getInt(MapBrowser.PREF_LONGITUDE, MapBrowser.DEFAULT_LONGITUDE)), 1, mGameData);
				if (items != null) {
					return true;
				} else {
					return false;
				}		
			} else {
				return false;
			}
		} else {
			return false;
		}
	}
	
	private void makeAlertSound(){
		// TODO: Check Alert Sound and do it...if you can implement sound go ahead
		// otherwise toast the sound level
		
		int soundMode = mGameData.getInt(SettingsMenu.PREF_ALERTSOUND, 3);
		
		if (soundMode == 1) {
			// With Profile
			if (mGameData.getInt(SettingsMenu.PREF_SOUND, 2) == 1) {
				// Sound Occurs Always
				int volMode = mGameData.getInt(SettingsMenu.PREF_VOLUME, 4);
				if (volMode < 4) {
					Toast.makeText(ItemScanner.this, SettingsMenu.mVolume[volMode], Toast.LENGTH_SHORT).show();
				}
			}
		} else if (soundMode == 2) {
			// Always
			Toast.makeText(ItemScanner.this, "System Sound Level", Toast.LENGTH_SHORT).show();
			
		}
	}
	
	private void doAlertMode(){
		// TODO: Again Check Alert mode and do the notification either in task bar
		// popup or launch app...
		// look at my showNotification() to see how task bar or launch is done
		// you should know how to do popup by now...
		
		int alertMode = mGameData.getInt(SettingsMenu.PREF_ALERTMODE, 3);
		
		if (alertMode == 0) {
			// Task Bar
	        Intent appIntent = new Intent(this, Launcher.class);   
	     	Intent contentIntent = new Intent(this, MapBrowser.class);
	        Notification note = new Notification(this,                        // our context
	                							 R.drawable.miniicon,             // the icon for the status bar
	                							 "Been There, Done That!",     // the text to display in the ticker
	                							 System.currentTimeMillis(),  // the timestamp for the notification
	                							 "Item Found!", // the title for the notification
	                							 "An item has been found in your area.",// the details to display in the notification
	                							 contentIntent,               // the contentIntent (see above)
	                							 R.drawable.icon ,  // the app icon
	                							 getText(R.string.app_name), // the name of the app
	                							 appIntent);// the appIntent (see above)   
	        mNotificationManager.notify(NOTIFICATION_ID, note);  // unique id to cancel notification		
		} else if (alertMode == 1) {
			// Pop-Up Note
			showAlert("Been There, Done That!", 0, "An item is within range to be picked up", "OK", null , false, null);
		
		} else if (alertMode == 2) {
			// Launch Application
			Intent contentIntent = new Intent(this, MapBrowser.class);
			contentIntent.addLaunchFlags(Intent.NEW_TASK_LAUNCH);
			startActivity(contentIntent);
		}
	}
	
	private void showNotification() {
        // This intent will just launch the app to start screen
        Intent appIntent = new Intent(this, Launcher.class);
        
        // This intent will allow the user to jump to mapbrowser by selecting the notification
        Intent contentIntent = new Intent(this, MapBrowser.class);

        Notification note = new Notification(this,                        // our context
                							 R.drawable.miniicon,             // the icon for the status bar
                							 null,                        // the text to display in the ticker
                							 System.currentTimeMillis(),  // the timestamp for the notification
                							 "Service Running!", // the title for the notification
                							 "Been There, Done That!",// the details to display in the notification
                							 contentIntent,               // the contentIntent (see above)
                							 R.drawable.icon ,  // the app icon
                							 getText(R.string.app_name), // the name of the app
                							 appIntent);// the appIntent (see above)   
        mNotificationManager.notify(NOTIFICATION_ID, note);  // unique id to cancel notification
    }   
}
