package edu.berkeley.cs160.group7.BeenThereDoneThatHiFi;

import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

public class MainMenu extends Activity {

	// Shared preferences file where all the game data like username will be stored
	public static SharedPreferences mGameData = null;
    public static SharedPreferences.Editor mGameDataEditor = null;

	// Possible activities that can be launched
	private static final int ACTIVITY_MAPBROWSER = 0;
	private static final int ACTIVITY_MANAGE_ITEM = 1;
	private static final int ACTIVITY_CURRENT_STATUS = 2;
	private static final int ACTIVITY_SETTINGS = 3;
	private static final int ACTIVITY_HELP = 4;
    
	private TextView mUserText;
	private ImageView mUserAvatar;
	private Button mFindButton, mDropButton, mStatusButton, mSettingsButton, mHelpButton;
	
	@Override
	protected void onCreate(Bundle icicle) {
		super.onCreate(icicle);
		mGameData = getSharedPreferences(Launcher.STORAGE_FILE,MODE_PRIVATE);
        mGameDataEditor = mGameData.edit();

		setContentView(R.layout.menu_main);
		mUserText = (TextView) findViewById(R.id.username_field);
		mUserAvatar = (ImageView) findViewById(R.id.avatar_field);
		mFindButton = (Button) findViewById(R.id.find_button);
		mDropButton = (Button) findViewById(R.id.drop_button);
		mStatusButton = (Button) findViewById(R.id.status_button);
		mSettingsButton = (Button) findViewById(R.id.settings_button);
		mHelpButton = (Button) findViewById(R.id.help_button);
		
		mUserText.setText(mGameData.getString("Username",null));
		if (mGameData.getInt("Avatar",-1) != -1 
				&& mGameData.getInt("Avatar",-1) != R.drawable.none){
			mUserAvatar.setImageResource(mGameData.getInt("Avatar",-1));
		}
		//showAlert("tes", 0,Integer.toString(R.drawable.none)+","+Integer.toString(mGameData.getInt("Avatar",-1)), "ok",false);
		
		//Open Intent Settings
		mSettingsButton.setOnClickListener(
			new OnClickListener() {
				public void onClick(View v) {
					gotoSettings();
				}
			});

		mFindButton.setOnClickListener(
			new OnClickListener() {
				public void onClick(View v) {
					gotoMapBrowser();
				}
			});
		mDropButton.setOnClickListener(
			new OnClickListener() {
				public void onClick(View v) {
					gotoManageItems();
				}
			});
		
		//Open Current Status
		mStatusButton.setOnClickListener(
			new	OnClickListener() {
				public void onClick(View v) {
					gotoCurrentStatus();
				}
			});
	
		// Open Help Menu
		mHelpButton.setOnClickListener(
			new OnClickListener() {
				public void onClick(View v) {
					gotoHelpMenu();
				}
			});
	}
	
    @Override
	protected void onResume() {
		super.onResume();
		//mUserAvatar.setImageResource(mGameData.getInt("Avatar",-1));
		//mGameData = getSharedPreferences(Launcher.STORAGE_FILE,MODE_PRIVATE);
		if (mGameData.getInt("Avatar",-1) != -1 
				&& mGameData.getInt("Avatar",-1) != R.drawable.none){
			mUserAvatar.setImageResource(mGameData.getInt("Avatar",-1));
		}else{
			mUserAvatar.setImageResource(0);
		}	
	}  

	@Override
	protected void onActivityResult(int requestCode, int resultCode,
			String data, Bundle extras) {
		switch (requestCode) {
		case ACTIVITY_SETTINGS:
			// update selected item on closing of the subactivity
			if (resultCode == RESULT_FIRST_USER){
				setResult(RESULT_FIRST_USER);
				finish();
			} return;
		default:
			super.onActivityResult(requestCode, resultCode, data, extras);
		}
	}

	private void gotoMapBrowser(){
		Intent i = new Intent(MainMenu.this,MapBrowser.class);
		startSubActivity(i, ACTIVITY_MAPBROWSER);
    }
    
    private void gotoManageItems(){
		Intent i = new Intent(MainMenu.this,ManageItem.class);
		startSubActivity(i, ACTIVITY_MANAGE_ITEM);
    }
	
    private void gotoCurrentStatus(){
		Intent i;
		i = new Intent(MainMenu.this, CurrentStatus.class);
		startSubActivity(i, ACTIVITY_CURRENT_STATUS);
	}
	
	private void gotoSettings(){
    	Intent i;
    	i = new Intent(MainMenu.this,SettingsMenu.class);
    	startSubActivity(i, ACTIVITY_SETTINGS);
    }

	private void gotoHelpMenu(){
		Intent i;
		i = new Intent(MainMenu.this, HelpMenu.class);
		startSubActivity(i, ACTIVITY_HELP);
	}
	

 

}
