package edu.berkeley.cs160.group7.BeenThereDoneThatHiFi;

import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;

import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.view.ViewInflate;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;

public class ManageItem extends Activity {
	
	// Shared preferences file where all the game data like username will be stored
	public static SharedPreferences mGameData = null;
    public static SharedPreferences.Editor mGameDataEditor = null;
	
	@Override
	protected void onCreate(Bundle icicle) {
		super.onCreate(icicle);
		setContentView(R.layout.manage_items);
		mGameData = getSharedPreferences(Launcher.STORAGE_FILE,MODE_PRIVATE);
		
		final ArrayList<MapBrowser.Item> itemslist = MapBrowser.getUserItem(mGameData);
		ListView mItemsList = (ListView) findViewById(R.id.items_list);
        mItemsList.setAdapter(new ItemsListAdapter(itemslist,R.layout.items_list_layout));
	}
	
	private class ItemsListAdapter extends BaseAdapter {

		private ArrayList<Drawable> mIconImages;
        private ArrayList<MapBrowser.Item> mItems;
		private int mLayoutId;
        
		public ItemsListAdapter(ArrayList<MapBrowser.Item> items, int item_layout) {
        	mItems = new ArrayList<MapBrowser.Item>(items);
        	mLayoutId = item_layout;
            if (mItems.size()>0){
            	mIconImages = new ArrayList<Drawable>();
            	for(MapBrowser.Item i : items)
            	{
            		try {
            			//Given a single image URL, load the image and create a Drawable image in
            			URL url;
            			URLConnection connection;
            			url = new URL(i.mIconUrl);
            			connection = url.openConnection();
            			InputStream is = connection.getInputStream(); 
            			mIconImages.add(Drawable.createFromStream(is,i.mIconUrl));
            			is.close(); 	
            		} catch (IOException e){ 
            			//Output details about any exceptions to the Android log (viewable in the LogCat panel in Eclipse).
            			Log.e(this.toString(), e.getMessage());
            		}
            	}
            }
        }
        
        @Override
        public int getCount() {
			return mItems.size();
		}
        
        @Override
		public Object getItem(int position) {
			return mItems.get(position);
		}

        @Override
		public long getItemId(int position) {
			return mItems.get(position).mId;
		}
   
        @Override
		public View getView(int position, View convertView, ViewGroup parent) {
			View v = inflateView(mLayoutId);
			ImageView i = (ImageView) v.findViewById(R.id.item_icon);
			TextView t1 = (TextView) v.findViewById(R.id.item_name);
			TextView t2 = (TextView) v.findViewById(R.id.item_description);
			i.setImageDrawable(mIconImages.get(position));
			t1.setText(mItems.get(position).mName);
			t2.setText(mItems.get(position).mDescription);	
        	return v;
		}
        
        private View inflateView(int resource) {
            ViewInflate vi = (ViewInflate)getSystemService(Context.INFLATE_SERVICE);
            return vi.inflate(resource, null, null);
        }
	}
}
